#pragma once

#define PI 3.141592654

class CBWState
{
public:
	float a[5];	// coefficients
	float i[2];	// past inputs
	float o[2];	// past outputs
	float ri[2];	// past right inputs (for stereo mode)
	float ro[2];	// past right outputs
	int IdleCount;
};

// work modes
#define WM_NOIO		0
#define WM_READ		1
#define WM_WRITE	2
#define WM_READWRITE	3

#define BW_SETTLE_TIME          256

#define QUIET 0.1

void DSP_Init(int const samplerate);

void DSP_BW_Reset(CBWState &s);
void DSP_BW_InitLowpass(CBWState &s, float const f);
void DSP_BW_InitHighpass(CBWState &s, float const f);
void DSP_BW_InitBandpass(CBWState &s, float const f, float const bw);
void DSP_BW_InitBandreject(CBWState &s, float const f, float const bw);
bool DSP_BW_Work(CBWState &s, float *ps, int const n, int const mode);
bool DSP_BW_WorkStereo(CBWState &s, float *ps, int const n, int const mode);


